from StringIO import StringIO

from Products.Archetypes.public import listTypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin
from Products.CMFCore.utils import getToolByName

from Products.Relations.config import *
import Products.Relations.jig as jig
import Products.Relations.Extensions.utils as utils

def install_tools(self, out):
    if hasattr(self, REFERENCEJIGREGISTRY):
        print >> out, "ReferenceJigRegistry already existed."
        return
    pt = getToolByName(self, 'portal_types')
    pt.constructContent('Jig Registry', self, REFERENCEJIGREGISTRY)
    registry = getattr(self, REFERENCEJIGREGISTRY)
    t = pt.getTypeInfo('Jig Registry').Title()
    registry.setTitle("%s: %s" % (PROJECTNAME, t))

    # register as ActionProvider
    at = getToolByName(self, 'portal_actions')
    at.addActionProvider(REFERENCEJIGREGISTRY)
    
    print >> out, "%s installed." % t

def install_dependencies(self, out):
    DEPS = 'Archetypes',
    qi = self.portal_quickinstaller
    qi.installProducts(DEPS)
    print >> out, "Installed dependencies: %s" % DEPS

def install(self):
    out = StringIO()

    install_dependencies(self, out)
    installTypes(self, out, listTypes(PROJECTNAME), PROJECTNAME)
    install_subskin(self, out, GLOBALS)
    install_tools(self, out)
    print >> out, utils.installConfiglet(self, CONFIGLETS)

    print >> out, "Successfully installed %s." % PROJECTNAME
    return out.getvalue()

def uninstall(self):
    out = StringIO()
    # XXX: Why does QuickInstaller think we own Archetypes' portal objects?
    at = getattr(self.portal_quickinstaller, 'Archetypes')
    NO_REMOVE = [REFERENCEJIGREGISTRY] + at.portalobjects
    prod = getattr(self.portal_quickinstaller, PROJECTNAME)
    prod.portalobjects = [p for p in prod.portalobjects if p not in NO_REMOVE]
    print >> out, utils.uninstallConfiglet(self, CONFIGLETS)

    print >> out, "Successfully uninstalled %s." % PROJECTNAME
    return out.getvalue()
