import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Products.CMFTestCase import CMFTestCase
CMFTestCase.setupCMFSite()

import common
common.installProducts()
CMFTestCase.setupCMFSite()

import Products.Relations.processor as processor

class TestProcessor(CMFTestCase.CMFTestCase):

    TYPES = 'SimpleType', 'ComplexType'
    JIGS = 'OneJig', 'AnotherJig'

    def afterSetUp(self):
        common.installWithinPortal(self, self.portal)
        self.objs = common.createObjects(self, self.TYPES)
        self.jigs = [common.createJig(self, j) for j in self.JIGS]

    def testConnectAndDisconnect(self):
        triples = [(self.objs[0].UID(), self.objs[1].UID(), jig.getId())
                   for jig in self.jigs]
        processor.process(self.portal, connect=triples)
        for jig in self.jigs:
            self.assertEquals(self.objs[0].getRefs(jig.getId())[0],
                              self.objs[1])

        processor.process(self.portal, disconnect=triples)
        self.assertEquals(len(self.objs[0].getRefs()), 0)
        self.assertEquals(len(self.objs[1].getBRefs()), 0)        

def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestProcessor))
    return suite

if __name__ == '__main__':
    framework()
